// Server.java

import java.net.*;
import java.io.*;
import java.text.SimpleDateFormat;
import java.util.*;

/**
	uEŨNGXg󂯕tHTTPT[oNX
	@version	1.0		08/12/2000
	@author		Takahiro Shigemoto
*/
public class Server
{
	int server_port;

	private final String[] server_response_header = {
		"HTTP/1.0 200 OK",
		"Server: HogeHoge_Server/1.0",
		"Content-Type: text/html",
		"Date: " + getRFC1123String(),
		"",
		"<html>",
		"<head>",
		"<title>Browser Request Viewer</title>",
		"</head>",
		"",
		"<body bgcolor = \"#FAFAFA\">",
		"<h2 align = \"center\">Browser's Request</h2>",
	};

	private final String[] server_response_footer = {
		"</body>",
		"</html>",
	};

	/*
		RFC1123`GMTԂ
		Sat, 12 Aug 2000 02:30:45 GMT
	**/
	private static final String getRFC1123String()
	{
		SimpleDateFormat sdf = new SimpleDateFormat("EEE, dd MMM yyyy hh:mm:ss zzz", Locale.US);
		sdf.setTimeZone(TimeZone.getTimeZone("GMT"));
		return(sdf.format(new Date()));
	}

	/*
		|[gw肵HTTPT[o\z
		@param	server_port	T[rX񋟂|[gԍ
	**/
	public Server(int server_port)
	{
		try
		{
			ServerSocket ss = new ServerSocket(server_port);

			// C[v
			while(true)
			{
				// NCAg\Pbg̎擾I/Ȍ
				Socket s = ss.accept();
				service(s);
			}
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}

	/**
		NCAgɑ΂ăT[rXs
		@param	s	NCAg\Pbg
	*/
	public void service(Socket s)
	{
		try
		{
			// NCAg̃NGXgi[p
			ArrayList request = new ArrayList();

			// NCAg\PbgI/O
			BufferedReader reader = new BufferedReader(new InputStreamReader(s.getInputStream()));
			PrintWriter    writer = new PrintWriter(new OutputStreamWriter(s.getOutputStream()));

			// NCAgNGXgwb_̎擾
			String buf;						// ǂݍݗpobt@
			int content_length = 0;			// Content-Length
			boolean end_header_flg = false;	// wb_ǂݍݏItrueɂȂ

			while((buf = reader.readLine()) != null)
			{
				request.add(buf);

				// GeBeBǂݍݏIŁAS̓ǂݍݏI
				if(end_header_flg == true)
					break;

				// sI[ȂAwb_ǂݍݏI
				if(buf.trim().length() == 0)
					end_header_flg = true;

				// Content-Length̎擾 (Content-Length: len)
				if(buf.toLowerCase().indexOf("content-length") != -1)
					content_length = Integer.parseInt((buf.substring(buf.indexOf(':') + 1)).trim());

				// GeBeBꍇAS̓ǂݍݏI
				if(end_header_flg == true && content_length == 0)
					break;
			}

			// NCAgւ̃X|X
			// X|Xwb_
			printStringArray(server_response_header, writer);

			// uEŨNGXg
			for(int i=0; i<request.size(); i++)
			{
				writer.println(request.get(i) + "<br>");
			}

			// tb^
			printStringArray(server_response_footer, writer);

			writer.flush();
			s.close();
		}
		catch(IOException io_ex)
		{
			io_ex.printStackTrace();
		}
	}

	/**
		o͗p[eBeB\bh
		@param	array	o͂镶
		@param	writer	o͗pPrintWriter
	*/
	private void printStringArray(String[] array, PrintWriter writer)
	{
		for(int i=0; i<array.length; i++)
		{
			writer.println(array[i]);
		}
		writer.flush();
	}
}